{*******************************************************}
{                                                       }
{ Turbo Pascal Version 7.0                              }
{    /             }
{                                      }
{                                                       }
{ Copyright(C) Faronov V.V.                             }
{                                                       }
{ Portions Copyright(C) Linus Gates & Bill Torvalds     }
{ 2004-2018                                             }
{                                                       }
{*******************************************************}
{E+, H-}
{$ifdef fpc}
{$A1}
{$endif}

Unit F_Grtext;

Interface

Uses Dos,Graph;

Const
  AppHandle:Boolean = True;
  EscFlag:Boolean   = False;

Const
  EmptyBorder = 0;
  SingleBorder = 1;
  DoubleBorder = 2;

Const
  Borderchar: Array [0..2,1..6] Of Char = (
  ( #32,  #32,  #32,  #32,  #32,  #32),
  (#218, #196, #191, #179, #192, #217),
  (#201, #205, #187, #186, #200, #188)
  );

Const
  TextCenter = 2;
  TextDown   = 3;
  TextUp     = 1;
  TextLeft   = 3;
  TextRight  = 1;

Function RegisterCHRFile(S:{$ifdef fpc}ShortString{$else}String{$endif}):SmallInt;
Procedure OutString(S:{$ifdef fpc}ShortString{$else}String{$endif};Font:SmallInt;Angle:SmallInt;Mx,My:Real);
Procedure OutStringXY(X,Y:Word;Stroka:{$ifdef fpc}ShortString{$else}String{$endif});
Procedure AllFont;
Procedure SetTextAlign(Horiz,Vert:Word);
Procedure SetStyleText(Font:Word;Direction:Word;CharSize:Word);

Implementation

Type
  Aob = Array[0..MaxSmallInt] Of Byte;

Const
  Changewr:Boolean = False;
  Font:^Aob = Nil;
  TCol:Byte = LightGray;
  BCol:Byte = Black;

Var
  OldOut,OldInp:Text;
  Xt:Byte;
  Xg:SmallInt;
  Yt:Byte;
  Yg:SmallInt;
  X1T,Y1T,X2T,Y2T:Byte;
  X1G,Y1G,X2G,Y2G:SmallInt;
  MaxChar:Byte;
  MaxLine:Byte;
  Xf:Byte;
  Yf:Byte;
  Adapter:Byte;
 {+---------------------------------------------+
  |           |
  |                                     |
  +---------------------------------------------+}
Type
  PFontDesc=^TFontDesc;
  TFontDesc = Record
    NextFont :PFontDesc;
    NFont    :SmallInt;
    Name: Record
      Case Byte Of
        0: (FName:{$ifdef fpc}ShortString{$else}String{$endif});
        1: (Flag:Byte;
          Addrs:Record
              Sa,Oa:Word
          End)
    End;
    FirstChr:Byte;
    LastChar:Byte;
    Height:ShortInt;
    Bottom:ShortInt;
    Offs:Array [0..255] Of Word;
    Leng:Array [0..255] Of Word;
  End;

  TFontPara = Record
    ParPrefix: Char;
    CharsCount: Word;
    Reserv1:Byte;
    FirstChar:Byte;
    DataOffset:Word;
    FillFlag:Byte;
    UpperMargin:Byte;
    Reserv2:Byte;
    LowerMargin:ShortInt;
    Reserv3:Array [1..5] Of Byte
  End;
  THead = Array [1..4] Of Char;

Const
  FontList:PFontDesc = Nil;
  FontNumb:SmallInt  = 0;

Var
  FDesc:TFontDesc;
  F:File;
  Buf:Array[1..128] Of Byte;
  Head:THead Absolute Buf;
  Fpar:TFontPara;

Const
  Head0:THead = ('P','K',#8,#8);

Function RegisterCHRFile(S:{$ifdef fpc}ShortString{$else}String{$endif}):SmallInt;
Var
  K:SmallInt;
  Err:Boolean;
  P,Pd:PFontDesc;
  Paroffs:Word;
Function ReadFile(Var Dest;Size:Word):Boolean;
Begin
  BlockRead(F,Dest,Size,K);
  ReadFile:=K=Size
End;
Begin
  If Pos('.',S)=0 Then
    S:=S+'.chr';
  If FontNumb<>0 Then
  Begin
    FDesc:=FontList^;
    With FDesc Do
      While (NextFont<>Nil) And (S<>Name.FName) Do
        FDesc:=NextFont^;
    If S=FDesc.Name.FName Then
    Begin
      RegisterCHRFile:=FDesc.NFont;
      Exit
    End
  End;
  RegisterCHRFile:=-1;
  Assign(F,S);
  {$I-}
  Reset(F,1);
  {$I+}
  If IOResult<>0 Then
    Exit;
  If Not ReadFile(Buf,128) Then
  Begin
    Close(F);
    Exit;
  End;
  RegisterCHRFile:=-2;
  If Head<>Head0 Then
  Begin
    Close(F);
    Exit;
  End;
  Repeat
    K:=1;
    While (K<=128) And (Buf[K]<>$1A) Do
      Inc(K);
    If K=129 Then
      If Not ReadFile(Buf,128) Then
      Begin
        Close(F);
        Exit
      End;
  Until Buf[K]=$1A;
  Paroffs:=Buf[K+1]+Buf[K+2] ShL 8;
  Seek(F,Paroffs);
  If Not ReadFile(Fpar,16) Or (Fpar.ParPrefix<>'+') Then
  Begin
    Close(F);
    Exit;
  End;
  RegisterCHRFile:=-3;
  {  If MaxAvail<SizeOf(TFontDesc) Then
    Exit;
}
  New(Pd);
  With Pd^,Fpar Do
  Begin
    NextFont:=Nil;
    NFont:=FontNumb+1;
    Name.FName:=S;
    FirstChr:=FirstChar;
    LastChar:=FirstChar+CharsCount-1;
    Height:=UpperMargin;
    Bottom:=LowerMargin;
    RegisterCHRFile:=-1;
    Seek(F,Paroffs+DataOffset-3*CharsCount);
    If Not ReadFile(Offs[FirstChar],2*CharsCount) Then
    Begin
      Dispose(Pd);
      Close(F);
      Exit
    End;
    For K:=FirstChar To LastChar-1 Do
      Leng[K]:=Offs[K+1]-Offs[K];
    Leng[LastChar]:=FileSize(F)-Offs[LastChar]-DataOffset-Paroffs;
    K:=Leng[LastChar];
    For K:=FirstChar To LastChar Do
      Offs[K]:=Offs[K]+Paroffs+DataOffset;
  End;
  If FontNumb=0 Then
    FontList:=Pd
  Else
  Begin
    P:=FontList;
    While P^.NextFont<>Nil Do
      P:=P^.NextFont;
    P^.NextFont:=Pd
  End;
  Inc(FontNumb);
  Close(F);
  RegisterCHRFile:=FontNumb
End;
{function registerchrfont(font:pointer):SmallInt;
type
    tbyte = array [0..65534] of byte;
var
   ph:^thead;
   pp:^tfontpara;
   pb:^tbyte absolute ph;
   p,pd:pfontdesc;
K:SmallInt;
   Paroffset:Word;
   FileSize:Word;
Begin
  Ph:=Font;
  Registerchrfont:=-2;
  If Ph^<>Head0 Then
    Exit;
  K:=4;
  While (Pb^[K] <> $1A) And (K<256) Do
    Inc(K);
  If Pb^[K] <> $1A Then
    Exit;
  Paroffset:=Pb^[K+1]+Pb^[K+2] ShL 8;
  FileSize:=Pb^[K+7]+Pb^[K+8] ShL 8;
  Pp:=Addr(Pb^[Paroffset]);
  If Pp^.ParPrefix <> '+' Then
    Exit;
  Registerchrfont:=-3;
  If MaxAvail<SizeOf(TFontDesc) Then
    Exit;
  New(Pd);
  With Pd^,Pp^ Do
  Begin
    NextFont:=Nil;
    NFont:=FontNumb+1;
    Name.Flag:=0;
    K:=Paroffset+DataOffset;
    Name.Addrs.Sa:=0;
    Name.Addrs.Oa:=Ofs(Pb^[K]);
    FirstChr:=FirstChar;
    LastChar:=FirstChar+CharsCount-1;
    Height:=UpperMargin;
    Bottom:=LowerMargin;
    K:=Paroffset+DataOffset-3*CharsCount;
    Move(Pb^[K],Offs[FirstChar],2*CharsCount);
    For K:=FirstChar To LastChar-1 Do
      Leng[K]:=Offs[K+1]-Offs[K];
    Leng[LastChar]:=FileSize-Offs[LastChar-1]
  End;
  If FontNumb=0 Then
    FontList:=Pd
  Else
  Begin
    P:=FontList;
    While P^.NextFont <> Nil Do
      P:=P^.NextFont;
    P^.NextFont:=Pd
  End;
  Inc(FontNumb);
  Registerchrfont:=FontNumb
End;}
Procedure OutString(S:{$ifdef fpc}ShortString{$else}String{$endif};Font:SmallInt;Angle:SmallInt;Mx,My:Real);
Var
  X0,Y0:SmallInt;
  Ang:Real;
Procedure OutChar(Var V);
Var
  Vec:Array[1..MaxSmallInt] Of Word Absolute V;
  K,Op:Word;
Procedure Coo(X,Y:SmallInt;Var Xx,Yy:SmallInt);
Var
  R,A:Single;
Begin
  R:=Sqrt(1.0*X*X+1.0*Y*Y);
  If X=0 Then If Y<0 Then
    A:=-Pi/2
  Else
    A:=Pi/2
  Else
    A:=(ArcTan(Y/X));
  If (X<0) And (Y<0) Then A:=A+Pi;
  A:=A+Ang;
  Yy:=(Round(R*Sin(A)));
  Xx:=(Round(R*Cos(A)));
End;
Var
  X,Y,X1,Y1,Xx,Yy:SmallInt;
Begin
  K:=1;
  X:=X0;
  Y:=Y0;
  Repeat
    Op:=Vec[K] And $8080;
    Xx:=Vec[K] And $7F;
    Yy:=(Vec[K] ShR 8) And $7F;
    If Yy>63 Then
      Yy:=Yy-128;
    If Xx>63 Then
      Xx:=Xx-128;
    Xx:=Round(Xx*Mx);
    Yy:=Round(Yy*My);
    Coo(Xx,Yy,X1,Y1);
    X1:=X0+X1;
    Y1:=Y0-Y1;
    If Op=$8080 Then
      Line(X,Y,X1,Y1);
    If Op<>0 Then
    Begin
      X:=X1;
      Y:=Y1;
    End;
    If Op=0 Then
    Begin
      X0:=X;
      Y0:=Y;
    End
    Else
      Inc(K)
  Until Op=0
End;
Var
  F:File;
  K,J:Word;
  C:Byte;
  Buf:Array[1..1000] Of Word;
  P:PFontDesc;
  Pb:Pointer;
Begin
  If (FontNumb=0) Or
     (Font>FontNumb) Or (S='') Then
    Exit;
  P:=FontList;
  Ang:=Angle*Pi/180;
  For K:=1 To Font-1 Do
    P:=P^.NextFont;
  With P^ Do
  Begin
    If Name.FName<>'' Then
    Begin
      Assign(F,Name.FName);
      {$I-}
      Reset(F,1);
      {$I+}
      If IOResult <> 0 Then
        Exit;
    End;
    X0:=GetX;
    Y0:=GetY;
    For K:=1 To Length(S) Do
    Begin
      C:=Ord(S[K]);
      If C In [FirstChr..LastChar] Then
        If Name.FName<>'' Then
        Begin
          {$I-}
          Seek(F,Offs[C]);
          BlockRead(F,Buf,Leng[C],J);
          {$I+}
          If (IOResult=0) And (Leng[C]=J) Then
            OutChar(Buf)
        End
      Else
        With Name.Addrs Do
        Begin
          Pb:=Pointer(Ptr(Sa, Oa+Offs[C]));
          OutChar(Pb^)
        End
    End;
    MoveTo(X0,Y0);
    If Name.FName<>'' Then
      Close(F)
  End
End;

Var
  TextAngle:Word;
  TextCharSizeX:Real;
  TextCharSizeY:Real;
  CurrentFont:Word;
  AlignX:Word;
  AlignY:Word;

Procedure AllFont;
Begin
  RegisterCHRFile('trip.chr');
  RegisterCHRFile('litt.chr');
  RegisterCHRFile('sans.chr');
  RegisterCHRFile('goth.chr');
  RegisterCHRFile('scri.chr');
  RegisterCHRFile('simp.chr');
  RegisterCHRFile('tscr.chr');
  RegisterCHRFile('lcom.chr');
  RegisterCHRFile('euro.chr');
  RegisterCHRFile('bold.chr');
End;

Procedure SetTextAlign(Horiz,Vert:Word);
Begin
  AlignX:=Horiz;
  AlignY:=Vert;
End;

Procedure SetStyleText(Font:Word;Direction:Word;CharSize:Word);
Begin
  TextAngle:=Direction;
  TextCharSizeX:=CharSize/4;
  TextCharSizeY:=CharSize/4;
  CurrentFont:=Font;
End;

Procedure OutStringXY(X,Y:Word;Stroka:{$ifdef fpc}ShortString{$else}String{$endif});
Const
  Shirina:Array[1..10] Of Byte =
  (45,15,45,50,50,40,48,49,76,50);
  Visota:Array[1..10] Of Byte =
  (55,15,50,50,50,50,50,50,105,50);
Var
  Rasm10:Real;
  Rasmxx:Real;
Begin
  Case AlignX Of
    1:X:=X;
    2:Begin X:=X-Round(Length(Stroka)*TextCharSizeX*4*Shirina[CurrentFont]/ 20);End;
    3:Begin X:=X-Round(Length(Stroka)*TextCharSizeX*4*Shirina[CurrentFont] / 10);End;
  End;
  Case AlignY Of
    1:Y:=Y;
    2:Y:=Y+Round(TextCharSizeY*4*Visota[CurrentFont]/20);
    3:Y:=Y+Round(TextCharSizeY*4*Visota[CurrentFont]/10);
  End;
  MoveTo(X,Y);
  OutString(Stroka,CurrentFont,TextAngle,TextCharSizeX,TextCharSizeY);
End;

Begin
  AllFont;
  SetStyleText(1,1,10);
End.