{*******************************************************}
{ Card Game                                             }
{                                                       }
{ Copyright(C) Linus Gates & Bill Torvalds 2004-2018    }
{                                                       }
{*******************************************************}

{$ifdef fpc}
{$ASMMODE Intel}
{$endif}

Uses Graph,Crt,F_Grtext,BMPUnit,Dos,Mouse,Strings{$ifdef fpc},go32{$endif};
Type
  Eq = (Inset,NotInset);
Var
  CompCard1:Byte;
  CompCard2:Byte;
  CompVal1:Byte;
  CompVal2:Byte;
  Prom:Byte;    {   }

  YourCard:Byte;
  YourValue:Byte;
  I:Byte;
  Gd,Gm:Integer;
  _N1,_N2:Eq;
  F:File;       {   }
  P:Pointer;    {   }
  As1:TBitmap;
  CH:Char;
  St:String;
  OldX, OldY:Word;
  Act:Byte;
  ParamString:String;
  MousePresent:Boolean;
Const
  fSize = 303556;
  Limit:LongInt = 1000;             {   }
  Cards:String  = 'CARDS\';         {    }
  Girl:String   = 'GIRLS.GLB';      {      }
  ColorDepth:Byte = 32;
  EasyGame:Boolean=False;
  DisableMouse:Boolean=false;
  LeftMouseButtonPressed:Boolean=False;
Function Int2Str(B:LongInt):String;
Var
  S:String;
Begin
  Str(B,S);
  Int2Str:=S;
End;
Const
  VGAColors: Array [0..15] Of LongInt = (
    $000000,$00000A0,$000A000,$000A0A0,
    $A01C1C,$0A000A0,$644Aec0,$0C4C4C4,
    $686868,$00000Fc,$024Fc24,$000Fcfc,
    $Fc2800,$0B000Fc,$0Fcfc20,$0Fcfcfc);

Const
  Active:Byte     = 5;
  Rate:LongInt    = 100;
  Money:LongInt   = 900;
  DRate           = 100;          {  -   }
  MAXRate:LongInt = 100;

Procedure DrawMouse(X,Y: Word {$ifdef fpc}; BitBltMode: Byte {$endif});
Const
  Mouseptr: Array [0..119] Of LongInt = (
    $Fcfcfc, $000000, $000000, $000000, $000000, $000000, $000000, $000000,
    $Fcfcfc, $Fcfcfc, $000000, $000000, $000000, $000000, $000000, $000000,
    $Fcfcfc, $Fcfcfc, $Fcfcfc, $000000, $000000, $000000, $000000, $000000,
    $Fcfcfc, $Fcfcfc, $Fcfcfc, $Fcfcfc, $000000, $000000, $000000, $000000,
    $Fcfcfc, $Fcfcfc, $Fcfcfc, $Fcfcfc, $Fcfcfc, $000000, $000000, $000000,
    $Fcfcfc, $Fcfcfc, $Fcfcfc, $Fcfcfc, $Fcfcfc, $Fcfcfc, $000000, $000000,
    $Fcfcfc, $Fcfcfc, $Fcfcfc, $Fcfcfc, $Fcfcfc, $Fcfcfc, $Fcfcfc, $000000,
    $Fcfcfc, $Fcfcfc, $Fcfcfc, $Fcfcfc, $Fcfcfc, $Fcfcfc, $Fcfcfc, $Fcfcfc,
    $Fcfcfc, $Fcfcfc, $Fcfcfc, $Fcfcfc, $Fcfcfc, $000000, $000000, $000000,
    $Fcfcfc, $Fcfcfc, $000000, $Fcfcfc, $Fcfcfc, $000000, $000000, $000000,
    $Fcfcfc, $000000, $000000, $000000, $Fcfcfc, $Fcfcfc, $000000, $000000,
    $000000, $000000, $000000, $000000, $Fcfcfc, $Fcfcfc, $000000, $000000,
    $000000, $000000, $000000, $000000, $000000, $Fcfcfc, $Fcfcfc, $000000,
    $000000, $000000, $000000, $000000, $000000, $Fcfcfc, $Fcfcfc, $000000,
    $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
    );
  Mouseptr16: Array [0..119 {$ifdef fpc} + 6 {$endif}] Of Word = (
    {$ifdef fpc}  $0008, $0000, $000F, $0000, $0000, $0000, {$endif}
    $ffff, $0000, $0000, $0000, $0000, $0000, $0000, $0000,
    $ffff, $ffff, $0000, $0000, $0000, $0000, $0000, $0000,
    $ffff, $ffff, $ffff, $0000, $0000, $0000, $0000, $0000,
    $ffff, $ffff, $ffff, $ffff, $0000, $0000, $0000, $0000,
    $ffff, $ffff, $ffff, $ffff, $ffff, $0000, $0000, $0000,
    $ffff, $ffff, $ffff, $ffff, $ffff, $ffff, $0000, $0000,
    $ffff, $ffff, $ffff, $ffff, $ffff, $ffff, $ffff, $0000,
    $ffff, $ffff, $ffff, $ffff, $ffff, $ffff, $ffff, $ffff,
    $ffff, $ffff, $ffff, $ffff, $ffff, $0000, $0000, $0000,
    $ffff, $ffff, $0000, $ffff, $ffff, $0000, $0000, $0000,
    $ffff, $0000, $0000, $0000, $ffff, $ffff, $0000, $0000,
    $0000, $0000, $0000, $0000, $ffff, $ffff, $0000, $0000,
    $0000, $0000, $0000, $0000, $0000, $ffff, $ffff, $0000,
    $0000, $0000, $0000, $0000, $0000, $ffff, $ffff, $0000,
    $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000
    );

Begin
  If ColorDepth = 16 then
    {$ifndef fpc} PutSprite(X, Y, X + 7, Y + 14, Mouseptr16) {$else} PutImage(X, Y, MousePtr16, BitBltMode) {$endif}
  else
    {$ifndef fpc} PutSprite(X, Y, X + 7, Y + 14, Mouseptr); {$else} PutImage(X, Y, Mouseptr, BitBltMode); {$endif}
End;

Procedure hnd(Mask, Buttons, X, Y, MovX, MovY: System.Word);
Begin
  LeftMouseButtonPressed:=(Buttons and $1) = $1;
  If (OldX = X) and (OldY = Y) Then
    Exit;
  {$ifndef fpc}
  SetWriteMode(XORPut);
  {$endif}
  DrawMouse(OldX, OldY{$ifdef fpc}, XORPut {$endif});
  DrawMouse(X, Y{$ifdef fpc}, XORPut {$endif});
  {$ifndef fpc}
  SetWriteMode(NormalPut);
  {$endif}
  OldX:=X;
  OldY:=Y;
End;

Procedure _Box(Position:Byte;Selected:Boolean);
Begin
  If Selected Then
    SetLineStyle(0,1,3)
  Else
    SetLineStyle(0,1,1);
  Case Position Of
    1:Rectangle(25,420,135,479);
    2:Rectangle(145,420,255,479);
    3:Rectangle(265,420,375,479);
    4:Rectangle(385,420,495,479);
    5:Rectangle(505,420,615,479);
    //   6:Rectangle(525,420,615,479);
  End;
  SetLineStyle(0,1,1);
End;

Procedure ShowCard(S:String);
Begin
  As1.Init(S);
  As1.ShowBitmap(138,40);
  As1.Done;
End;

Procedure Quit;
Begin
  If MousePresent Then
    DoneMouse;
  CloseGraph;
  FreeMem(P,fSize);
  Close(F);
  Halt(0);
End;

Procedure CrashQuit;
Const
  GameOver:String='GAME OVER';
Begin
  SetStyleText(8,HorizDir,9);
  SetColor(VGAColors[7]);
  OutStringXY(307,245,GameOver);
  OutStringXY(308,246,GameOver);
  OutStringXY(309,247,GameOver);
  SetColor(VGAColors[3]);
  OutStringXY(300,240,GameOver);
  OutStringXY(301,240,GameOver);
  OutStringXY(302,240,GameOver);
  OutStringXY(303,240,GameOver);
  OutStringXY(304,240,GameOver);
  Repeat
  Until KeyPressed;
  Readkey;
  If MousePresent Then
    DoneMouse;
  CloseGraph;
  FreeMem(P,fSize);
  Close(F);
  Halt(0);
End;

Procedure RedrawMoneAndRate;
Begin
  SetStyleText(2,HorizDir,7);
  OutStringXY(250,200,Int2Str(Money)+'$');
  OutStringXY(250,250,Int2Str(Rate)+'$');
  OutStringXY(250,300,Int2Str(Limit)+'$');
End;

Procedure UpdateBitmap;
Var
  P16:Pointer;
  ImageSize:LongInt;
  L:LongInt;
Begin
  If EoF(F) Then
    Exit;                         {  ,     }
  If Money+Rate<Limit Then
    Exit;                         { ,        }
  BlockRead(F,P^,1);              {    }
  If ColorDepth = 16 then         {    16  }
  begin
    ImageSize:= LongInt((Word(p^) + 1) * (Word((p+2)^ ) + 1)) shl 2;
    GetMem(P16, ImageSize + {$ifdef fpc}12{$else}4{$endif});
    {$ifdef fpc}
    FillChar(p16^,12,#0);
    LongInt((p16)^):=Word(p^) + 1;
    LongInt((p16+4)^):=Word((p+2)^) + 1;
    {$else}
    Move(p^, p16^, 4);
    {$endif}
    L:=0;
    Repeat
      Word((p16+{$ifdef fpc}12{$else}4{$endif}+(L div 2))^):=_32to16bit(LongInt((p+4+L)^));
      inc(L,4);
    Until L = ImageSize;
    PutImage(374,2,P16^ {$ifdef fpc},NormalPut{$endif});        {    }
    FreeMem(P16, ImageSize + {$ifdef fpc}12{$else}4{$endif});
  end
  else                         {      32  }
    PutImage(374,2,P^ {$ifdef fpc},NormalPut{$endif});        {    }
  Limit:=Limit + 1000;         {    -    1000 }
End;

Function FileExist(S:String):Boolean;
Var
  Dirinfo: SearchRec;
Begin
  FileExist:=False;
  FindFirst(S, AnyFile, Dirinfo);
  If DosError<>0 Then
    Exit;
  If (Dirinfo.Attr And VolumeID <> VolumeID) Then
    FileExist:=True;
End;

Function AppPath:String;
Var
  _Dir,_Name,_Ext:String;
Begin
  {$V-}
  FSplit(ParamStr(0),_Dir,_Name,_Ext);
  AppPath:=_Dir;
  {$V+}
End;

procedure RedrawMouse;
begin
  If MousePresent and (oldY>=420-16) And (oldY<=479) Then
  Begin
    {$ifndef fpc}
    SetWriteMode(XORPut);
    {$endif}
    DrawMouse(OldX, OldY{$ifdef fpc}, XORPut {$endif});
    {$ifndef fpc}
    SetWriteMode(NormalPut);
    {$endif}
  End;
end;

{$ifdef fpc}
function LeftButtonPressed:Boolean;
begin
 LeftButtonPressed:=(GetMouseButtons and MouseLeftButton) = MouseLeftButton;
End;

function UpperCase(Str:ShortString):ShortString;
Var
  B:Byte;
Begin
  For B:=1 to Length(Str) do
    Str[B]:=UpCase(Str[B]);
  Exit(Str);
End;

{$ifndef win32}
procedure SetMouseRange(MinX, MinY, MaxX, MaxY: DWord);Assembler;
Asm
  Mov ax, $0007
  Mov ecx, MinX
  Mov edx, MaxX
  Int $33
  Mov ax, $0008
  Mov ecx, MinY
  Mov edx, MaxY
  Int $33
End;

{$endif}

{$endif}

Begin
  Cards:=AppPath+Cards;      {    }
  If ParamCount>=1 Then      {      }
    For I:=1 to ParamCount do
    Begin
      ParamString:=UpperCase(ParamStr(I));
      If FileExist(AppPath+ParamString) Then {    }
        Cards:=AppPath+ParamString+'\';    {        }
      If ParamString = '/16' Then
        ColorDepth:=16;
      If ParamString = '/EASY' Then
        EasyGame:=True;
      If ParamString = '/NM' Then
        DisableMouse:=True;
      If (ParamString = '/H') or (ParamString = '/?') Then
      begin
        Writeln('Card game by Linus Gates & Bill Torvalds. Specially for the Downgrade magazine, 2018. Usage:');
        Writeln('game.exe [/h] [/?] [/16] [/easy] [CardCoverDir]');
        Writeln('  /h, /? - This help screen');
        Writeln('  /16    - Use 16 bit SVGA mode');
        Writeln('  /easy  - Easy game');
        Writeln('  /nm    - Disable mouse');
        Writeln('  CardCoverDir - Relative path to card cover directory');
        Exit;
      end;
    End;

  Assign(F,Girl);          {     }
  {$I-}
  Reset(F,fSize);
  {$I+}
  If IOResult <> 0 Then
    Halt(1);

  If FileSize(F)<>24 Then
  Begin
    Close(F);
    Halt(1); { ,     24 - - }
  End;
  If DisableMouse Then
    MousePresent:=false
  else
  Begin
    InitMouse;
    {$ifndef fpc}
    MousePresent:=(GetButtonCount > 0);
    {$else}
    MousePresent:=(DetectMouse > 0);
    {$endif}
  End;
  If MousePresent Then
    HideMouse;
  GetMem(P,fSize);         {     }
  {$ifndef fpc}
  SetSVGAMode(640,480,ColorDepth,0);
  {$else}
  ColorDepth:=16;
  {$ifdef win32}
  GM:=m640x480x64k;
  {$else}
  GD:=D16bit;
  GM:=m640x480;
  {$endif}
  InitGraph(Gd, Gm, '');
  {$endif}
  If GraphResult <> grOk Then
  Begin
    RestoreCRTMode;
    Writeln('Sorry, your graphic card not supported, upgrade you hardware and retry.');
    Exit;
  End;
  If MousePresent Then
  Begin
    SetMouseRange($000000, $000000, GetMaxX, GetMaxY);
    {$ifndef fpc}
    SetMousePos(0,0);
    {$else}
    SetMouseXY(0,0);
    {$endif}
    DrawMouse(0, 0{$ifdef fpc}, NormalPut {$endif});
    OldX:=0;
    OldY:=0;
    {$ifndef fpc}
    SetMouseHandler($FFFF, hnd);
    {$endif}
  end;

  If ColorDepth = 16 Then
  Begin
    For I:=0 to 15 do
      VGAColors[I]:=_32to16bit(VGAColors[I]);
  End;

  Randomize;                 {     }
  SetColor(VGAColors[1]);
  _Box(1,False);     {    }
  _Box(2,False);
  _Box(3,False);
  _Box(4,False);
  _Box(5,True);
  //   _Box(6,True);      {     }
  SetTextAlign(TextCenter, TextCenter);
  SetColor(VGAColors[5]);
  Rectangle(25,1,615,410);
  Line(320,1,320,410);
  Line(173,170,173,350);
  Line(25,170,320,170);
  Line(25,350,320,350);
  SetColor(VGAColors[2]);
  SetStyleText(2,HorizDir,7);
  OutStringXY(560,448,'Exit');
  //   OutStringXY(470,448,'Equal =');

  OutStringXY(440,448,'Out <>');
  OutStringXY(320,448,'In ><');
  SetStyleText(2,HorizDir,5);
  OutStringXY(200,440,'Lower');
  OutStringXY(200,460,'rate -');
  OutStringXY(80,440,'Raise');
  OutStringXY(80,460,'rate +');

  OutStringXY(70,20,'First Card');
  OutStringXY(270,20,'Second Card');
  OutStringXY(173,20,'You Card');
  SetColor(VGAColors[1]);
  SetStyleText(2,HorizDir,7);
  OutStringXY(100,200,'Money');
  OutStringXY(100,250,'Rate');
  OutStringXY(100,300,'Limit');
  UpdateBitmap;        {      }
  RedrawMoneAndRate;
  Repeat

    Repeat
      CompCard1:=Random(52)+1;    {     }

      For I:=1 To CompCard1 Do
        Random(100);           {    }
      Repeat
        CompCard2:=Random(52)+1;
      Until (CompCard2 <> CompCard1) or (CompCard1 mod 13 <> CompCard2 mod 13); {    }

      For I:=1 To CompCard2 Do
        Random(CompCard1);     {    }

      {        }
      CompVal1:=(CompCard1+13) Mod 13;
      If CompVal1=0 Then
        CompVal1:=13;

      CompVal2:=(CompCard2+13) Mod 13;
      If CompVal2=0 Then
        CompVal2:=13;

      If CompVal1>CompVal2 Then   {  1  2 ,  }
      Begin
        Prom:=CompVal1;           {   }
        CompVal1:=CompVal2;
        CompVal2:=Prom;

        Prom:=CompCard1;          {   }
        CompCard1:=CompCard2;
        CompCard2:=Prom;
      End;

    Until ((CompVal2 - CompVal1 > 1) and
          (CompVal2 - CompVal1 < 11)) or EasyGame;

    Repeat
      YourCard:=Random(52)+1;             {    }
    Until (YourCard<>CompCard1) And (YourCard<>CompCard2);

    {             }
    YourValue:=(YourCard+13) Mod 13;
    If YourValue=0 Then
      YourValue:=13;

    If (YourValue>=CompVal1) And (YourValue<=CompVal2) Then
      _N1:=Inset
    Else
      _N1:=NotInset;

    If EasyGame Then
      MAXRate:=Limit - (Money + Rate)
    Else Case (CompVal2 - CompVal1) Of
      0,1,2,10,11,12:MAXRate:=100;
      3,4,8,9:MAXRate:=200;
      5,7:MAXRate:=    400;
      6:MAXRate:=      800;
    End;
    If (Rate > MAXRate) Then
    Begin
      Money:=Money + Rate - MAXRate;
      Rate:=MAXRate;
    End;

    SetColor(VGAColors[1]);
    RedrawMoneAndRate;

    As1.Init(Cards+Int2Str(CompCard1)+'.bmp');      {first Card}
    As1.ShowBitmap(35,40);
    As1.Done;

    As1.Init(Cards+Int2Str(CompCard2)+'.bmp');      {second Card}
    As1.ShowBitmap(240,40);
    As1.Done;

    As1.Init(Cards+'0.bmp');  {   }
    As1.ShowBitmap(138,40);
    As1.Done;
    Repeat
      CH:=' ';
      Act:=Active;
      While (LeftMouseButtonPressed) Do {    }
      Begin
        CH:=' ';                     {   }
        If (oldY>=420) And (oldY<=479) Then {      }
        Begin
          Case oldX Of   {      }
             25..135:Begin Act:=1;CH:=#13;End;
            145..255:Begin Act:=2;CH:=#13;End;
            265..375:Begin Act:=3;CH:=#13;End;
            385..495:Begin Act:=4;CH:=#13;End;
            505..614:Quit;
          End;

          If Act<>Active Then  {         }
          Begin                {        }
            RedrawMouse;
            SetColor(0);
            _Box(Active,True);
            SetColor(VGAColors[1]);
            _Box(Active,False);
            Active:=Act;
            _Box(Active,True);
            RedrawMouse;
          End;
        End;
      End;
      While KeyPressed Do
        CH:=ReadKey;
      If CH=#0 Then
        CH:=ReadKey;
      Case CH Of
        #27:Quit;
        '4',#75:If Active>1 Then
        Begin
          RedrawMouse;
          SetColor(0);               {    }
          _Box(Active,True);         {     ,  }
          SetColor(VGAColors[1]);    {    }
          _Box(Active,False);        {    }
          Dec(Active);               {  '' }
          _Box(Active,True);         {    }
          RedrawMouse;
        End;
        '6',#77:If Active<5 Then
        Begin
          RedrawMouse;
          SetColor(0);
          _Box(Active,True);
          SetColor(VGAColors[1]);
          _Box(Active,False);
          Inc(Active);
          _Box(Active,True);
          RedrawMouse;
        End;
        #13:Begin
          Case Active Of
            1:If (Money>=Drate) and (Rate < MAXRate) Then {  $ ,  DX     }
            Begin
              SetColor(0);
              RedrawMoneAndRate;
              Money:=Money-Drate;
              Rate:=Rate+Drate;
              SetColor(VGAColors[1]);
              RedrawMoneAndRate;
            End;
            2:If Rate>Drate Then {   ,  DX     }
            Begin
              SetColor(0);
              RedrawMoneAndRate;
              Money:=Money+Drate;
              Rate:=Rate-Drate;
              SetColor(VGAColors[1]);
              RedrawMoneAndRate;
            End;
            3:Begin
               _N2:=Inset;
               Break;
              End;
            4:Begin
               _N2:=NotInset;
               Break;
              End;
            5:Quit;
          End;
        End;
      End;
    Until False;
    Case Active Of
      3,4:
      Begin
        ShowCard(Cards+Int2Str(YourCard)+'.bmp'); {    }
        If _N1=_N2 Then
           St:='Your Win!'               {   }
        Else
           St:='Computer Win!';
        SetColor(0);
        RedrawMoneAndRate;
        If _N1=_N2 Then
        Begin
          Money:=Money + Rate;
          UpdateBitmap;
        End
        Else
        Begin
          If Money = 0 Then
            CrashQuit;
          If Rate > Money Then
          Begin
            Rate:=Money;
            Money:=0;
          End
          Else
            Money:=Money - Rate;
        End;
        SetColor(VGAColors[14]);                      {     }
        SetStyleText(3,HorizDir,3);                   {   }
        OutStringXY(173,380,St);                      {   }
        Delay(1500);                                  {  }
        While Keypressed do
          Readkey;
        SetColor(0);                                  {  }
        OutStringXY(173,380,St);
      End;
    End;
  Until False;
  CloseGraph;
End.
